org.apache.xerces.dom

## Class PSVIAttrNSImpl

- java.lang.Object
- - org.apache.xerces.dom.NodeImpl
  - - org.apache.xerces.dom.AttrImpl
    - - org.apache.xerces.dom.AttrNSImpl
      - - org.apache.xerces.dom.PSVIAttrNSImpl

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, org.apache.xerces.xs.AttributePSVI, org.apache.xerces.xs.ItemPSVI, org.w3c.dom.Attr, org.w3c.dom.events.EventTarget, org.w3c.dom.Node, org.w3c.dom.NodeList, org.w3c.dom.TypeInfo

    public class PSVIAttrNSImpl
    extends AttrNSImpl
    implements org.apache.xerces.xs.AttributePSVI

Attribute namespace implementation; stores PSVI attribute items.

Version:
  $Id: PSVIAttrNSImpl.java 1024038 2010-10-18 22:06:35Z sandygao $
Author:
  Sandy Gao, IBM
See Also:
  Serialized Form

# INTERNAL:

  Usage of this class is not supported. It may be altered or removed at any time.

### Field Summary

Fields
`protected org.apache.xerces.xs.XSAttributeDeclaration` `fDeclaration` attribute declaration
`protected org.apache.xerces.xs.StringList` `fErrorCodes` error codes
`protected org.apache.xerces.xs.StringList` `fErrorMessages` error messages
`protected boolean` `fSpecified` If this attribute was explicitly given a value in the original document, this is true; otherwise, it is false
`protected org.apache.xerces.xs.XSTypeDefinition` `fTypeDecl` type of attribute, simpleType
`protected short` `fValidationAttempted` validation attempted: none, partial, full
`protected java.lang.String` `fValidationContext` validation context: could be QName or XPath expression
`protected short` `fValidity` validity: valid, invalid, unknown
`protected ValidatedInfo` `fValue` Schema value

### Fields inherited from class org.apache.xerces.dom.AttrNSImpl

`localName, namespaceURI`

### Fields inherited from class org.apache.xerces.dom.AttrImpl

`name, value`

### Fields inherited from class org.apache.xerces.dom.NodeImpl

`DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_IS_CONTAINED, DOCUMENT_POSITION_PRECEDING, ELEMENT_DEFINITION_NODE, FIRSTCHILD, flags, HASSTRING, ID, IGNORABLEWS, NORMALIZED, OWNED, ownerNode, READONLY, SPECIFIED, SYNCCHILDREN, SYNCDATA, TREE_POSITION_ANCESTOR, TREE_POSITION_DESCENDANT, TREE_POSITION_DISCONNECTED, TREE_POSITION_EQUIVALENT, TREE_POSITION_FOLLOWING, TREE_POSITION_PRECEDING, TREE_POSITION_SAME_NODE`

### Fields inherited from interface org.apache.xerces.xs.ItemPSVI

`VALIDATION_FULL, VALIDATION_NONE, VALIDATION_PARTIAL, VALIDITY_INVALID, VALIDITY_NOTKNOWN, VALIDITY_VALID`

### Fields inherited from interface org.w3c.dom.Node

`ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_POSITION_CONTAINED_BY, DOCUMENT_POSITION_CONTAINS, DOCUMENT_POSITION_DISCONNECTED, DOCUMENT_POSITION_FOLLOWING, DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC, DOCUMENT_POSITION_PRECEDING, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NOTATION_NODE, PROCESSING_INSTRUCTION_NODE, TEXT_NODE`

### Fields inherited from interface org.w3c.dom.TypeInfo

`DERIVATION_EXTENSION, DERIVATION_LIST, DERIVATION_RESTRICTION, DERIVATION_UNION`

### Constructor Summary

Constructors
Constructor and Description
`PSVIAttrNSImpl(CoreDocumentImpl ownerDocument, java.lang.String namespaceURI, java.lang.String qualifiedName)` Construct an attribute node.
`PSVIAttrNSImpl(CoreDocumentImpl ownerDocument, java.lang.String namespaceURI, java.lang.String qualifiedName, java.lang.String localName)` Construct an attribute node.

### Method Summary

All Methods Instance Methods Concrete Methods
`java.lang.Object` `getActualNormalizedValue()` `[schema normalized value]`: Binding specific actual value or `null` if the value is in error.
`short` `getActualNormalizedValueType()` The actual value built-in datatype, e.g.
`org.apache.xerces.xs.XSAttributeDeclaration` `getAttributeDeclaration()` An item isomorphic to the attribute declaration used to validate this attribute.
`org.apache.xerces.xs.StringList` `getErrorCodes()` A list of error codes generated from validation attempts.
`org.apache.xerces.xs.StringList` `getErrorMessages()` A list of error messages generated from the validation attempt or an empty `StringList` if no errors occurred during the validation attempt.
`boolean` `getIsSchemaSpecified()` [schema specified]
`org.apache.xerces.xs.ShortList` `getItemValueTypes()` In the case the actual value represents a list, i.e.

`org.apache.xerces.xs.XSSimpleTypeDefinition`

`getMemberTypeDefinition()`
If and only if that type definition is a simple type definition with {variety} union, or a complex type definition whose {content type} is a simple thype definition with {variety} union, then an item isomorphic to that member of the union's {member type definitions} which actually validated the element item's normalized value.

`java.lang.String` `getSchemaDefault()` [schema default]
`java.lang.String` `getSchemaNormalizedValue()` [schema normalized value]
`org.apache.xerces.xs.XSValue` `getSchemaValue()` If this item has a simple type definition or a complex type with simple content, then return the value with respect to the simple type.
`org.apache.xerces.xs.XSTypeDefinition` `getTypeDefinition()` An item isomorphic to the type definition used to validate this element.
`short` `getValidationAttempted()` Determines the extent to which the document has been validated
`java.lang.String` `getValidationContext()` The nearest ancestor element information item with a `[schema information]` property (or this element item itself if it has such a property).
`short` `getValidity()` Determine the validity of the node with respect to the validation being attempted
`void` `setPSVI(org.apache.xerces.xs.AttributePSVI attr)` Copy PSVI properties from another psvi item.

### Methods inherited from class org.apache.xerces.dom.AttrNSImpl

`getLocalName, getNamespaceURI, getPrefix, getTypeName, getTypeNamespace, isDerivedFrom, setPrefix`

### Methods inherited from class org.apache.xerces.dom.AttrImpl

`cloneNode, getChildNodes, getElement, getFirstChild, getLastChild, getLength, getName, getNodeName, getNodeType, getNodeValue, getOwnerElement, getSchemaTypeInfo, getSpecified, getValue, hasChildNodes, insertBefore, isEqualNode, isId, item, makeChildNode, normalize, removeChild, replaceChild, setIdAttribute, setNodeValue, setOwnerDocument, setReadOnly, setSpecified, setType, setValue, synchronizeChildren, toString`

### Methods inherited from class org.apache.xerces.dom.NodeImpl

`addEventListener, appendChild, changed, changes, compareDocumentPosition, compareTreePosition, dispatchEvent, getAttributes, getBaseURI, getContainer, getFeature, getNextSibling, getNodeNumber, getOwnerDocument, getParentNode, getPreviousSibling, getReadOnly, getTextContent, getUserData, getUserData, getUserDataRecord, hasAttributes, isDefaultNamespace, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, needsSyncChildren, removeEventListener, setTextContent, setUserData, setUserData, synchronizeData`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface org.w3c.dom.Node

`appendChild, compareDocumentPosition, getAttributes, getBaseURI, getFeature, getNextSibling, getOwnerDocument, getParentNode, getPreviousSibling, getTextContent, getUserData, hasAttributes, isDefaultNamespace, isSameNode, isSupported, lookupNamespaceURI, lookupPrefix, setTextContent, setUserData`

### Field Detail

#### fDeclaration

    protected org.apache.xerces.xs.XSAttributeDeclaration fDeclaration

attribute declaration

#### fTypeDecl

    protected org.apache.xerces.xs.XSTypeDefinition fTypeDecl

type of attribute, simpleType

#### fSpecified

    protected boolean fSpecified

If this attribute was explicitly given a value in the original document, this is true; otherwise, it is false

#### fValue

    protected ValidatedInfo fValue

Schema value

#### fValidationAttempted

    protected short fValidationAttempted

validation attempted: none, partial, full

#### fValidity

    protected short fValidity

validity: valid, invalid, unknown

#### fErrorCodes

    protected org.apache.xerces.xs.StringList fErrorCodes

error codes

#### fErrorMessages

    protected org.apache.xerces.xs.StringList fErrorMessages

error messages

#### fValidationContext

    protected java.lang.String fValidationContext

validation context: could be QName or XPath expression

### Constructor Detail

#### PSVIAttrNSImpl

    public PSVIAttrNSImpl(CoreDocumentImpl ownerDocument,
                          java.lang.String namespaceURI,
                          java.lang.String qualifiedName,
                          java.lang.String localName)

Construct an attribute node.

#### PSVIAttrNSImpl

    public PSVIAttrNSImpl(CoreDocumentImpl ownerDocument,
                          java.lang.String namespaceURI,
                          java.lang.String qualifiedName)

Construct an attribute node.

### Method Detail

#### getSchemaDefault

    public java.lang.String getSchemaDefault()

[schema default]

Specified by:
  `getSchemaDefault` in interface `org.apache.xerces.xs.ItemPSVI`
Returns:
  The canonical lexical representation of the declaration's {value constraint} value.
See Also:

  #### getSchemaNormalizedValue

      public java.lang.String getSchemaNormalizedValue()

  [schema normalized value]
  Specified by:
    `getSchemaNormalizedValue` in interface `org.apache.xerces.xs.ItemPSVI`
  Returns:
    the normalized value of this item after validation
  See Also:

    #### getIsSchemaSpecified

        public boolean getIsSchemaSpecified()

    [schema specified]
    Specified by:
      `getIsSchemaSpecified` in interface `org.apache.xerces.xs.ItemPSVI`
    Returns:
      false value was specified in schema, true value comes from the infoset
    See Also:
      XML Schema Part 1: Structures [schema specified]

    #### getValidationAttempted

        public short getValidationAttempted()

    Determines the extent to which the document has been validated
    Specified by:
      `getValidationAttempted` in interface `org.apache.xerces.xs.ItemPSVI`
    Returns:
      return the [validation attempted] property. The possible values are NO_VALIDATION, PARTIAL_VALIDATION and FULL_VALIDATION

    #### getValidity

        public short getValidity()

    Determine the validity of the node with respect to the validation being attempted
    Specified by:
      `getValidity` in interface `org.apache.xerces.xs.ItemPSVI`
    Returns:
      return the [validity] property. Possible values are: UNKNOWN_VALIDITY, INVALID_VALIDITY, VALID_VALIDITY

    #### getErrorCodes

        public org.apache.xerces.xs.StringList getErrorCodes()

    A list of error codes generated from validation attempts. Need to find all the possible subclause reports that need reporting
    Specified by:
      `getErrorCodes` in interface `org.apache.xerces.xs.ItemPSVI`
    Returns:
      list of error codes

    #### getErrorMessages

        public org.apache.xerces.xs.StringList getErrorMessages()

    A list of error messages generated from the validation attempt or an empty `StringList` if no errors occurred during the validation attempt. The indices of error messages in this list are aligned with those in the `[schema error code]` list.
    Specified by:
      `getErrorMessages` in interface `org.apache.xerces.xs.ItemPSVI`

    #### getValidationContext

        public java.lang.String getValidationContext()

    Description copied from interface: `org.apache.xerces.xs.ItemPSVI`
    The nearest ancestor element information item with a `[schema information]` property (or this element item itself if it has such a property). For more information refer to element validation context and attribute validation context .
    Specified by:
      `getValidationContext` in interface `org.apache.xerces.xs.ItemPSVI`

    #### getTypeDefinition

        public org.apache.xerces.xs.XSTypeDefinition getTypeDefinition()

    An item isomorphic to the type definition used to validate this element.
    Specified by:
      `getTypeDefinition` in interface `org.apache.xerces.xs.ItemPSVI`
    Returns:
      a type declaration

    #### getMemberTypeDefinition

        public org.apache.xerces.xs.XSSimpleTypeDefinition getMemberTypeDefinition()

    If and only if that type definition is a simple type definition with {variety} union, or a complex type definition whose {content type} is a simple thype definition with {variety} union, then an item isomorphic to that member of the union's {member type definitions} which actually validated the element item's normalized value.
    Specified by:
      `getMemberTypeDefinition` in interface `org.apache.xerces.xs.ItemPSVI`
    Returns:
      a simple type declaration

    #### getAttributeDeclaration

        public org.apache.xerces.xs.XSAttributeDeclaration getAttributeDeclaration()

    An item isomorphic to the attribute declaration used to validate this attribute.
    Specified by:
      `getAttributeDeclaration` in interface `org.apache.xerces.xs.AttributePSVI`
    Returns:
      an attribute declaration

    #### setPSVI

        public void setPSVI(org.apache.xerces.xs.AttributePSVI attr)

    Copy PSVI properties from another psvi item.
    Parameters:
      `attr` - the source of attribute PSVI items

    #### getActualNormalizedValue

        public java.lang.Object getActualNormalizedValue()

    Description copied from interface: `org.apache.xerces.xs.ItemPSVI`
    `[schema normalized value]`: Binding specific actual value or `null` if the value is in error.
    Specified by:
      `getActualNormalizedValue` in interface `org.apache.xerces.xs.ItemPSVI`

    #### getActualNormalizedValueType

        public short getActualNormalizedValueType()

    Description copied from interface: `org.apache.xerces.xs.ItemPSVI`
    The actual value built-in datatype, e.g. `STRING_DT, SHORT_DT`. If the type definition of this value is a list type definition, this method returns `LIST_DT`. If the type definition of this value is a list type definition whose item type is a union type definition, this method returns `LISTOFUNION_DT`. To query the actual value of the list or list of union type definitions use `itemValueTypes`. If the `actualNormalizedValue` is `null`, this method returns `UNAVAILABLE_DT`.
    Specified by:
      `getActualNormalizedValueType` in interface `org.apache.xerces.xs.ItemPSVI`

    #### getItemValueTypes

        public org.apache.xerces.xs.ShortList getItemValueTypes()

    Description copied from interface: `org.apache.xerces.xs.ItemPSVI`
    In the case the actual value represents a list, i.e. the `actualNormalizedValueType` is `LIST_DT`, the returned array consists of one type kind which represents the itemType . For example:

         <simpleType name="listtype"> <list
         itemType="positiveInteger"/> </simpleType> <element
         name="list" type="listtype"/> ... <list>1 2 3</list>

    The `schemaNormalizedValue` value is "1 2 3", the `actualNormalizedValueType` value is `LIST_DT`, and the `itemValueTypes` is an array of size 1 with the value `POSITIVEINTEGER_DT`.
    If the actual value represents a list type definition whose item type is a union type definition, i.e. `LISTOFUNION_DT`, for each actual value in the list the array contains the corresponding memberType kind. For example:

         <simpleType
         name='union_type' memberTypes="integer string"/> <simpleType
         name='listOfUnion'> <list itemType='union_type'/>
         </simpleType> <element name="list" type="listOfUnion"/>
         ... <list>1 2 foo</list>

    The `schemaNormalizedValue` value is "1 2 foo", the `actualNormalizedValueType` is `LISTOFUNION_DT` , and the `itemValueTypes` is an array of size 3 with the following values: `INTEGER_DT, INTEGER_DT, STRING_DT`.
    Specified by:
      `getItemValueTypes` in interface `org.apache.xerces.xs.ItemPSVI`

    #### getSchemaValue

        public org.apache.xerces.xs.XSValue getSchemaValue()

    Description copied from interface: `org.apache.xerces.xs.ItemPSVI`
    If this item has a simple type definition or a complex type with simple content, then return the value with respect to the simple type. If this item doesn't have a simple-typed value, the behavior of this method is not specified.
    Specified by:
      `getSchemaValue` in interface `org.apache.xerces.xs.ItemPSVI`